<?php
class AdminOrdersController extends AdminOrdersControllerCore
{

    public function __construct()
  {
      parent::__construct();

      if(Module::isEnabled('winddoc') && Configuration::get('PS_WINDDOC_ORDINI_ENABLE') == 1 ){
        $this->fields_list['winddoc_order'] = array(
            'title' => 'WindDoc Ordini',
            'filter_key' => 'a!id_order',
            'callback' => 'displayWinddocOrder',
            'orderby' => false,
            'search' => false,
            'remove_onclick' => true,
        );
      }
      if(Module::isEnabled('winddoc') && Configuration::get('PS_WINDDOC_FATTURE_ENABLE') == 1 ){
        unset($this->fields_list["id_pdf"]);
        $this->fields_list['winddoc_invoice'] = array(
            'title' => $this->l('WindDoc Fatture'),
            'filter_key' => 'a!id_order',
            'orderby' => false,
            'search' => false,
            'remove_onclick' => true,
            'callback' => 'displayWinddocInvoice'
        );
      }

  }


  public function displayWinddocInvoice($value,$order) {

    $det = Module::getInstanceByName('winddoc')->dettaglioOrdine($order['id_order']);
    $html = "";
    if(isset($det) && $det["id_invoice_winddoc"]!=""){
      $html = '<a class="btn btn-success _blank green" href="'.$det["url_invoice_winddoc"].'" target="_balnk"><i class="icon-download"></i> Scarica Fattura</a>';
    }else{
      if(Configuration::get("PS_WINDDOC_FATTURE_SINCRONIZZA_FATTURE")==0 || Configuration::get("PS_WINDDOC_FATTURE_SINCRONIZZA_FATTURE")==""){
        $link = new LinkCore;
        $html = '<a class="btn btn-warning _blank" target="_balnk" onclick="setTimeout(function(){location.reload();},500);" href="'.$link->getAdminLink('AdminWindDoc').'&type=crea_fattura&id_order='.$order["id_order"].'"><i class="icon-plus"></i> Crea Fattura</a>';
      }
    }
    return $html;
  }

    public function displayWinddocOrder($value,$order) {
      $det = Module::getInstanceByName('winddoc')->dettaglioOrdine($order['id_order']);
      $html = "";
      if(isset($det) && $det["id_ordine_winddoc"]!=""){
        $html = '<a class="btn btn-success _blank" href="'.$det["url_ordine_winddoc"].'" target="_balnk" ><i class="icon-download"></i> Scarica Ordine</a>';
      }else{
        if(Configuration::get("PS_WINDDOC_ORDINI_SINCRONIZZA_ORDINI")==0 || Configuration::get("PS_WINDDOC_ORDINI_SINCRONIZZA_ORDINI")==""){
          $link = new LinkCore;
          $html = '<a class="btn btn-warning _blank" target="_balnk" onclick="setTimeout(function(){location.reload();},500);" href="'.$link->getAdminLink('AdminWindDoc').'&type=crea_ordine&id_order='.$order["id_order"].'"><i class="icon-plus"></i> Crea Ordine</a>';
        }
      }
      return $html;
  }
}
