<?php

class winddoc extends Module
{
  public $root_login = 'https://app.winddoc.com/oauth-login.php?token_app=8e07ba5637b912f08a414de463212ccbaf06aa8b1633efff7bb90bb375d9293b';
  public $root = 'https://app.winddoc.com';


  public function __construct(){
    $this->name = 'winddoc';
    $this->tab = 'administration';
    $this->version = '1.0.0';
    $this->author = 'Morri Luca';
    $this->need_instance = 0;
    $this->ps_versions_compliancy = array('min' => '1.6', 'max' => _PS_VERSION_);
    $this->bootstrap = true;

    $this->displayName = $this->l('winddoc.com');
    $this->description = $this->l('Sincronizza le tue Fatture con WindDoc');
    parent::__construct();

  }

  public function install(){
    if (!parent::install())
      return false;


      $sql= "CREATE TABLE IF NOT EXISTS `"._DB_PREFIX_."winddoc_sinc_order`(

        `id` int(11) unsigned NOT NULL auto_increment,
        `data_creazione` DateTime,
        `data_modifica` DateTime,
        `sales_flat_order_id` int(11),
        `id_ordine_winddoc` CHAR(36),
        `id_invoice_winddoc` CHAR(36),
        `url_invoice_winddoc` text,
        `url_ordine_winddoc` text,
        PRIMARY KEY (`id`)
      ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
      ";
      if(!$result=Db::getInstance()->Execute($sql)){
        return false;
      }

      $sql= "CREATE TABLE IF NOT EXISTS `"._DB_PREFIX_."winddoc_sinc_customer`(

        `id` int(11) unsigned NOT NULL auto_increment,
        `data_creazione` DateTime,
        `data_modifica` DateTime,
        `customer_id` int(11),
        `id_customer_winddoc` CHAR(36),
        PRIMARY KEY (`id`)
      ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
      ";
      if(!$result=Db::getInstance()->Execute($sql)){
        return false;
      }


      if(!$this->registerHook('actionValidateOrder')){
        $this->registerHook('actionValidateOrder');
      }

      if(!$this->registerHook('actionOrderStatusPostUpdate'))
          $this->registerHook('actionOrderStatusPostUpdate');

      if(!$this->registerHook('actionOrderStatusUpdate')){
        $this->registerHook('actionOrderStatusUpdate');
      }


    return true;
  }

  public $param = array("PS_WINDDOC_TOKEN",
                        "PS_WINDDOC_CONTATTI_SINCRONIZZA_CONTATTO",
                        "PS_WINDDOC_ORDINI_ENABLE",
                        "PS_WINDDOC_ORDINI_SINCRONIZZA_ORDINI",
                        "PS_WINDDOC_ORDINI_MAGAZZINO",
                        "PS_WINDDOC_ORDINI_TEMPLATE",
                        "PS_WINDDOC_ORDINI_NUMERAZIONE",

                        "PS_WINDDOC_FATTURE_ENABLE",
                        "PS_WINDDOC_FATTURE_SINCRONIZZA_FATTURE",
                        "PS_WINDDOC_FATTURE_MAGAZZINO",
                        "PS_WINDDOC_FATTURE_TEMPLATE",
                        "PS_WINDDOC_FATTURE_PAGAMENTO",
                        "PS_WINDDOC_FATTURE_NUMERAZIONE",
                        "PS_WINDDOC_FATTURE_SEND_EMAIL",

                        "PS_WINDDOC_RICEVUTE_SINCRONIZZA_RICEVUTE",
                        "PS_WINDDOC_RICEVUTE_TEMPLATE",
                        "PS_WINDDOC_RICEVUTE_PAGAMENTO",
                        "PS_WINDDOC_RICEVUTE_NUMERAZIONE"

                      );
  public function getContent(){
    $output = null;

    if (Tools::isSubmit('submitModule')){
      foreach ($this->param as $value) {
        if(isset($_REQUEST[$value])){
          Configuration::updateValue($value, $_REQUEST[$value]);
        }
      }
    }
    $this->context->smarty->assign('winddoc_enable',Module::isEnabled('winddoc'));
    $this->context->smarty->assign('winddoc_login_url',$this->root_login);
    $this->context->smarty->assign('ps_winddoc_url',$this->root);
    //Recupera

    $template_q = $this->getTemplateQuote();
    $this->context->smarty->assign('ps_winddoc_list_template_quote', $template_q);
    $template_i = $this->getTemplateInvoice();
    $this->context->smarty->assign('ps_winddoc_list_template_invoice', $template_i);

    $template_r = $this->getTemplateRicevute();
    $this->context->smarty->assign('ps_winddoc_list_template_ricevute', $template_r);

    $conti_l = $this->getConti();
    $this->context->smarty->assign('ps_winddoc_list_conti', $conti_l);

    foreach ($this->param as $value) {
      $this->context->smarty->assign($value,Configuration::get($value));
    }

    $output .= $this->display(__FILE__, 'views/templates/admin/form.tpl');
    return $output;
  }



  public function hookActionOrderStatusPostUpdate($order) {
    //qui gegnero ricevuta

    if(!Module::isEnabled('winddoc') || Configuration::get('PS_WINDDOC_ORDINI_ENABLE') == 0 || Configuration::get('PS_WINDDOC_ORDINI_SINCRONIZZA_ORDINI') == 0){
      return;
    }

    $det = $this->dettaglioOrdine($order['id_order']);
    if(!isset($det["id_ordine_winddoc"]) || $det["id_ordine_winddoc"]==""){
      //verifico se ho emesso la fattura

      $url = $this->creaOrdine($order);

    }
  }


  //Si attiva quando lo stato dell'ordine è impostato come pagato
  public function hookActionOrderStatusUpdate($order) {


      if(!Module::isEnabled('winddoc') || !$order['newOrderStatus']->paid || Configuration::get('PS_WINDDOC_FATTURE_ENABLE') == 0 ||  Configuration::get("PS_WINDDOC_FATTURE_SINCRONIZZA_FATTURE")!=1){
        return;
      }

      $det = $this->dettaglioOrdine($order['id_order']);
      if(!isset($det["id_invoice_winddoc"]) || $det["id_invoice_winddoc"]==""){
        //verifico se ho emesso la fattura

        $url = $this->creaFattura($order);

      }
  }

  //Si attiva quando viene creato un'ordine
  public function hookActionValidateOrder($order){

      if(Module::isEnabled('winddoc') && Configuration::get("PS_WINDDOC_ORDINI_SINCRONIZZA_ORDINI")==1){
        if(isset($order['order'])){
          $mo = $order['order'];
        }else{
          $mo = $order['objOrder'];
        }
        $this->addNewOrder($mo->id);
      }
  }




  public function creaOrdine($order){
    $data = $this->getDataFromOrder($order['id_order'],"ordini");


    //Verifico se devo salvare il cliente
    if(Configuration::get('PS_WINDDOC_CONTATTI_SINCRONIZZA_CONTATTO')==1){
      $id_contatto = $this->sincroCustomerByOrder($order);
      $data["id_contatto"] = $id_contatto;
    }
    //verifico se devo inviare l'email

    $WindDocTalker = new WindDocTalker();

    $data = $WindDocTalker->sendDocument($data,$data["document_type"]);

    if(!isset($data["id"])){
      $this->context->controller->success[] = $this->l('Non è stato possibile creare l\'ordine in WindDoc');
    }else{
      $this->aggiungiWinDocToOrder($order['id_order'],$data["id"],$data["url"]);
      $this->context->controller->confirmations[] = $this->l('Ordine Creato correttamente in WindDoc.');
    }
    return ;
  }

  public function creaFattura($order){
    $data = $this->getDataFromOrder($order['id_order'],"fatture");


    //Verifico se devo salvare il cliente
    if(Configuration::get('PS_WINDDOC_CONTATTI_SINCRONIZZA_CONTATTO')==1){
      $id_contatto = $this->sincroCustomerByOrder($order);
      $data["id_contatto"] = $id_contatto;
    }

    $det = $this->dettaglioOrdine($order['id_order']);

    if(isset($det["id_ordine_winddoc"]) && $det["id_ordine_winddoc"]!=""){
      $data["relation"][0]["parent_type"] = "ordini";
      $data["relation"][0]["parent_id"] = $det["id_ordine_winddoc"];
    }

    //verifico se devo inviare l'email
    if(Configuration::get('PS_WINDDOC_FATTURE_SEND_EMAIL')==1){
      $data["send_email"] = true;
    }


    $WindDocTalker = new WindDocTalker();

    $data = $WindDocTalker->sendDocument($data,$data["document_type"]);



    if(!isset($data["id"])){
      $this->context->controller->success[] = $this->l('Non è stato possibile creare la fattura in WindDoc');
    }else{
      $this->aggiungiWinDocToInvoice($order['id_order'],$data["id"],$data["url"]);
      $this->context->controller->confirmations[] = $this->l('Fattura Creata correttamente in WindDoc.');
    }
    return ;
  }


  public function aggiungiWinDocToOrder($sales_flat_order_id,$id_ordine_winddoc,$url_ordine_winddoc){
    if(!$this->dettaglioOrdine($sales_flat_order_id)){
        $this->addNewOrder($sales_flat_order_id);
    }

    Db::getInstance()->execute("UPDATE `"._DB_PREFIX_."winddoc_sinc_order` set id_ordine_winddoc = '".$id_ordine_winddoc."', url_ordine_winddoc = '".$url_ordine_winddoc."' WHERE sales_flat_order_id = '".$sales_flat_order_id."'");
  }

  public function aggiungiWinDocToInvoice($sales_flat_order_id,$id_invoice_winddoc,$url_invoice_winddoc){
    if(!$this->dettaglioOrdine($sales_flat_order_id)){
        $this->addNewOrder($sales_flat_order_id);
    }

    Db::getInstance()->execute("UPDATE `"._DB_PREFIX_."winddoc_sinc_order` set id_invoice_winddoc = '".$id_invoice_winddoc."', url_invoice_winddoc = '".$url_invoice_winddoc."' WHERE sales_flat_order_id = '".$sales_flat_order_id."'");
  }

  public function getIdCustomerWinddoc($id_customer){
    $det = $this->dettaglioSincroCustomer($id_customer);
    if(isset($det["id_customer_winddoc"])){
      return $det["id_customer_winddoc"];
    }
    return false;
  }

  public function dettaglioOrdine($sales_flat_order_id = ""){
    $det = Db::getInstance()->getRow("SELECT * FROM `" . _DB_PREFIX_ . "winddoc_sinc_order` WHERE `sales_flat_order_id` = '" .$sales_flat_order_id . "'");
    if(isset($det)){
      return $det;
    }
    return false;
  }


  public function dettaglioSincroCustomer($id_customer){
    $det = Db::getInstance()->getRow("SELECT * FROM `" . _DB_PREFIX_ . "winddoc_sinc_customer` WHERE `customer_id` = '" .$id_customer . "'");
    if(isset($det)){
      return $det;
    }
    return false;
  }

  public function aggiungiSincroCustomer($customer_id,$id_customer_winddoc){

    Db::getInstance()->execute('INSERT INTO `'._DB_PREFIX_.'winddoc_sinc_customer` (data_creazione,data_modifica,customer_id,id_customer_winddoc)
                                                                         VALUES (NOW(),NOW(),"'.$customer_id.'","'.$id_customer_winddoc.'")');

  }

  public function addNewOrder($id){
    Db::getInstance()->execute('INSERT INTO `'._DB_PREFIX_.'winddoc_sinc_order` (sales_flat_order_id,data_creazione,data_modifica,id_ordine_winddoc,id_invoice_winddoc,url_invoice_winddoc,url_ordine_winddoc)
                                                                           VALUES ("'.$id.'",NOW(),NOW(),"","","","")');
  }

  public function getDataFromOrder($id_order,$type=""){

    $order = new Order($id_order);
    $indirizzo_fatturazione = new Address($order->id_address_invoice);
    $indirizzo_spedizione = new Address($order->id_address_delivery);
    $customer = new Customer($indirizzo_fatturazione->id_customer);



    $data = array();
    $data["document_type"] = $type;
    if($type=="fatture"){
      $data["numerazione"] = Configuration::get("PS_WINDDOC_FATTURE_NUMERAZIONE");
    }
    if($type=="ricevute"){
      $data["numerazione"] = Configuration::get("PS_WINDDOC_RICEVUTE_NUMERAZIONE");
    }
    if($type=="ordini"){
      $data["numerazione"] = Configuration::get("PS_WINDDOC_ORDINI_NUMERAZIONE");
    }
    $data["valuta"] = "e994378e-c24b-12e2-cb41-5717c48cdc99"; //Impostiamo di defaut €


    if($this->getIdCustomerWinddoc($order->id_customer)!=""){
      $data["id_contatto"] = $this->getIdCustomerWinddoc($order->id_customer);
    }




    if($indirizzo_fatturazione->vat_number=="" && $indirizzo_fatturazione->dni!=""){
      //E' un privato
      if($type=="fatture"){
        if(Configuration::get("PS_WINDDOC_RICEVUTE_SINCRONIZZA_RICEVUTE")==1){
          $data["numerazione"] = Configuration::get("PS_WINDDOC_ORDINI_NUMERAZIONE");
          $data["document_type"] = "ricevute";
          $type = "ricevute";
        }
      }



      $data["contatto_nome"] = trim($indirizzo_fatturazione->firstname." ".$indirizzo_fatturazione->lastname);
      $data["contatto_codice_fiscale"] = $indirizzo_fatturazione->dni;
      $data["contatto_ragione_sociale"] = "";
      $data["contatto_indirizzo_citta"] = $indirizzo_fatturazione->city;
      $Country = new Country($indirizzo_fatturazione->id_country);
      $data["contatto_indirizzo_nazione"] = $Country->iso_code;
      $data["contatto_indirizzo_cap"] = $indirizzo_fatturazione->postcode;
      if (!empty($indirizzo_fatturazione->id_state)){
          $state = new State($indirizzo_fatturazione->id_state);
          $data["contatto_indirizzo_provincia"] =$state->iso_code;
      }


      $data["contatto_indirizzo_via"] = trim($indirizzo_fatturazione->address1." ".$indirizzo_fatturazione->address2);


      $data["contatto_partita_iva"] = "";
      $data["contatto_email"] = $customer->email;
      $data["contatto_codice_destinatario"] = "";
      $data["contatto_email_pec"] = "";
    }else{
      //è un'azienda
      $data["contatto_nome"] = trim($indirizzo_fatturazione->firstname." ".$indirizzo_fatturazione->lastname);
      if($data["contatto_nome"]==""){
        $data["contatto_nome"] = $indirizzo_fatturazione->company;
      }
      $data["contatto_codice_fiscale"] = $indirizzo_fatturazione->dni;
      $data["contatto_ragione_sociale"] = $indirizzo_fatturazione->company;
      $data["contatto_indirizzo_citta"] = $indirizzo_fatturazione->city;
      $Country = new Country($indirizzo_fatturazione->id_country);
      $data["contatto_indirizzo_nazione"] = $Country->iso_code;
      $data["contatto_indirizzo_cap"] = $indirizzo_fatturazione->postcode;
      if (!empty($indirizzo_fatturazione->id_state)){
          $state = new State($indirizzo_fatturazione->id_state);
          $data["contatto_indirizzo_provincia"] =$state->iso_code;
      }

      $data["contatto_indirizzo_via"] = trim($indirizzo_fatturazione->address1." ".$indirizzo_fatturazione->address2);
      $data["contatto_partita_iva"] = $indirizzo_fatturazione->vat_number;
      $data["contatto_email"] = $customer->email;
      $data["contatto_codice_destinatario"] = "";
      $data["contatto_email_pec"] = "";
    }




    if($order->id_address_invoice != $order->id_address_delivery){

      //Aggiungo secondo intestatario
      $data["cointestatario"][0] = array();
      if($indirizzo_spedizione->vat_number=="" && $indirizzo_spedizione->dni!=""){
        //E' un privato
        $data["cointestatario"][0]["nome"] = trim($indirizzo_spedizione->firstname." ".$indirizzo_spedizione->lastname);
        $data["cointestatario"][0]["codice_fiscale"] = $indirizzo_spedizione->dni;
        $data["cointestatario"][0]["ragione_sociale"] = "";
        $data["cointestatario"][0]["indirizzo_citta"] = $indirizzo_spedizione->city;
        $Country = new Country($indirizzo_spedizione->id_country);
        $data["cointestatario"][0]["indirizzo_nazione"] = $Country->iso_code;

        $data["cointestatario"][0]["indirizzo_cap"] = $indirizzo_spedizione->postcode;

        if (!empty($indirizzo_spedizione->id_state)){
            $state = new State($indirizzo_spedizione->id_state);
            $data["cointestatario"][0]["indirizzo_provincia"] =$state->iso_code;
        }


        $data["cointestatario"][0]["indirizzo_via"] = trim($indirizzo_spedizione->address1." ".$indirizzo_spedizione->address2);
        $data["cointestatario"][0]["partita_iva"] = "";
        $data["cointestatario"][0]["email"] = $customer->email;
        $data["cointestatario"][0]["codice_destinatario"] = "";
        $data["cointestatario"][0]["email_pec"] = "";
      }else{
        //è un'azienda
        $data["cointestatario"][0]["nome"] = trim($indirizzo_spedizione->firstname." ".$indirizzo_spedizione->lastname);
        if($data["cointestatario"][0]["nome"]==""){
          $data["cointestatario"][0]["nome"] = $indirizzo_spedizione->company;
        }
        $data["cointestatario"][0]["codice_fiscale"] = $indirizzo_spedizione->dni;
        $data["cointestatario"][0]["ragione_sociale"] = $indirizzo_spedizione->company;
        $data["cointestatario"][0]["indirizzo_citta"] = $indirizzo_spedizione->city;
        $Country = new Country($indirizzo_spedizione->id_country);
        $data["cointestatario"][0]["indirizzo_nazione"] = $Country->iso_code;

        $data["cointestatario"][0]["indirizzo_cap"] = $indirizzo_spedizione->postcode;
        if (!empty($indirizzo_spedizione->id_state)){
            $state = new State($indirizzo_spedizione->id_state);
            $data["cointestatario"][0]["indirizzo_provincia"] =$state->iso_code;
        }

        $data["cointestatario"][0]["indirizzo_via"] = trim($indirizzo_spedizione->address1." ".$indirizzo_spedizione->address2);
        $data["cointestatario"][0]["partita_iva"] = $indirizzo_spedizione->vat_number;
        $data["cointestatario"][0]["email"] = $customer->email;
        $data["cointestatario"][0]["codice_destinatario"] = "";
        $data["cointestatario"][0]["email_pec"] = "";
      }
    }



    $totale = $order->total_paid_tax_incl;
    $vatAmount = $order->total_paid_tax_incl-$order->total_paid_tax_excl;
    $totalWithoutTax = $order->total_paid_tax_excl;



    //template_stampa
    if($type=="fatture"){
      $data["template_stampa"] = Configuration::get("PS_WINDDOC_FATTURE_TEMPLATE");
      $data["dicitura_invoice"] = "Riferimento Ordine ".$order->reference;
    }
    if($type=="ordini"){
      $data["template_stampa"] = Configuration::get("PS_WINDDOC_ORDINI_TEMPLATE");
      $data["dicitura_quote"] = "Riferimento Ordine ".$order->reference;
    }
    if($type=="ricevute"){
      $data["template_stampa"] = Configuration::get("PS_WINDDOC_RICEVUTE_TEMPLATE");
      $data["dicitura_invoice"] = "Riferimento Ordine ".$order->reference;
    }

    /* Differenti impostazioni per la generazione della fattura */
    //INPS - cassa/rivalsa
    //$data["cassa_rivalsa"] = 0;                     /* Valori permessi : ( 0 : Abilitata - 1 : Disabilitata)*/
    //$data["rivalsa_inps"] = 0.0;                    /* Valori permessi Float : indicare la percenutale di rivalsa INPS */
    //$data["cassa_previdenza"] = 0.0;                /* Valori permessi Float : indicare la percenutale di cassa previdenza */

    //Ritenuta d'acconto
    //$data["ritenuta_acconto_enable"] = 0;           /* Valori permessi : ( 0 : Abilitata - 1 : Disabilitata)*/
    //$data["ritenuta_acconto"] = 0.0;                /* Valori permessi Float : indicare la percenutale della ritenuta */
    //$data["ritenuta_acconto_su_imponibile"] = 0.0;  /* Valori permessi Float : indicare la percenutale da applicare al totale dell'imponibile*/


    //Altra ritenuta
    //$data["altra_ritenuta_enable"] = 0;             /* Valori permessi : ( 0 : Abilitata - 1 : Disabilitata)*/
    //$data["altra_ritenuta"] = 0.0;                  /* Valori permessi Float : indicare la percenutale della ritenuta */

    $iva_name = "";
    $iva_importo = "";
    $data["prodotto"] = array();
    $totale_calcolo = 0;
    foreach ($order->getProducts() as $product_detail) {

      $prodotto = array();
      $qty = $product_detail['product_quantity'];

      if($qty>0){
        $prodotto["quantita"] = $qty;
        $prodotto["prezzo_netto"] = $product_detail['product_price'];
        $vatCode = $product_detail['tax_rate'];

        $prodotto["codice"] = $product_detail['reference'];
        $prodotto["nome"] = $product_detail['product_name'];

        $prodotto["sconto"] = 0;
        $prodotto["iva_importo"] = $vatCode;
        $iva_importo = $vatCode;
        $prodotto["importo_totale"] =$product_detail['total_price_tax_incl'];

        $totale_calcolo = $totale_calcolo  + $prodotto["importo_totale"];

        $TaxRulesGroupCore = new TaxRulesGroupCore($product_detail["id_tax_rules_group"]);
        $prodotto["iva_name"] = $TaxRulesGroupCore->name;

        $prodotto["tipo_riga"] = 0; //Tipo riga prodotto
        $prodotto["unita_misura"] = "pz";


        if($type=="fatture" || $type=="ricevute"){
          if(Configuration::get("PS_WINDDOC_FATTURE_MAGAZZINO")==1){
            $prodotto["scarica_da_magazzino"] = 1;
          }
        }
        if($type=="ordini"){
          if(Configuration::get("PS_WINDDOC_ORDINI_MAGAZZINO")==1){
            $prodotto["scarica_da_magazzino"] = 1;
          }
        }

        $data["prodotto"][] = $prodotto;

      }
    }


    foreach ($order->getCartRules() as $cart_rule){

      $prodotto = array();
      $prodotto["quantita"] = "1";
      $prodotto["prezzo_netto"] = -$cart_rule['value_tax_excl'];
      $prodotto["iva_importo"] = round(($cart_rule['value']/$cart_rule['value_tax_excl']-1)*100);


      $prodotto["codice"] = "";
      $prodotto["nome"] = $cart_rule['name'];
      $prodotto["sconto"] = 0;
      $prodotto["importo_totale"] =-$cart_rule['value'];

      $totale_calcolo = $totale_calcolo  + $prodotto["importo_totale"];

      $prodotto["iva_name"] = "";
      $prodotto["tipo_riga"] = 2; //Tipo riga servizio
      $prodotto["unita_misura"] = "pz";
      $data["prodotto"][] = $prodotto;
    }
//Costo spedizione come servizio

    if ($order->total_shipping_tax_excl > 0){
        $prodotto = array();
        $prodotto["quantita"] = "1";
        $prodotto["prezzo_netto"] = $order->total_shipping_tax_excl;
        $prodotto["iva_importo"] = $order->carrier_tax_rate;

        $Carrire = new Carrier($order->id_carrier);
        $prodotto["codice"] = "";
        $prodotto["nome"] = "Costi di spedizione : ".$Carrire->name;
        $prodotto["sconto"] = 0;
        $prodotto["importo_totale"] = $order->total_shipping_tax_incl;
        $totale_calcolo = $totale_calcolo  + $prodotto["importo_totale"];

        $prodotto["iva_name"] = "";
        $prodotto["tipo_riga"] = 2; //Tipo riga servizio
        $prodotto["unita_misura"] = "pz";
        $data["prodotto"][] = $prodotto;

    }




    $totale_calcolo = round($totale_calcolo,2);
    $totale = round($totale,2);

    //Mancano le spese aggiuntive, tipo contrassegno

    if($totale_calcolo<$totale){
      $resto = $totale-$totale_calcolo;

      $prodotto = array();
      $prodotto["codice"] = "";
      $prodotto["nome"] = "Altri Servizi";
      $prodotto["prezzo_netto"] = round($resto/(1+($iva_importo/100)),2);
      $prodotto["iva_importo"] = $iva_importo;
      $prodotto["iva_name"] = $iva_name;
      $prodotto["importo_totale"] = $resto;

      $prodotto["sconto"] = 0;
      $prodotto["quantita"] = "1";
      $prodotto["tipo_riga"] = 2; //TIpo riga servizio
      $data["prodotto"][] = $prodotto;

      //Che iva prendo?
    }


    $totale = $order->total_paid_tax_incl;
    $data["scadenza"] = array();
    $data["scadenza"][0]["ammontare"] = $totale;
    $data["scadenza"][0]["termini"] = "0"; //Immediato
    $data["scadenza"][0]["scadenza"] = time();
    if($type == 'fatture'){
      $data["scadenza"][0]["id_conto"] = Configuration::get("PS_WINDDOC_FATTURE_PAGAMENTO");
      if($data["scadenza"][0]["id_conto"]!="0"){
        $data["scadenza"][0]["data_saldo"] = time();
      }
    }
    if($type == 'ricevute'){
      $data["scadenza"][0]["id_conto"] = Configuration::get("PS_WINDDOC_RICEVUTE_PAGAMENTO");
      if($data["scadenza"][0]["id_conto"]!="0"){
        $data["scadenza"][0]["data_saldo"] = time();
      }
    }


    //Mancano i costi aggiuntivi, tipo costo pagamento eccc...

    return $data;

  }


  public function sincroCustomerByOrder($order){
    //Verifico se il cliente è già sincronizzato

    $order = new Order($order['id_order']);
    $indirizzo_fatturazione = new Address($order->id_address_invoice);
    $indirizzo_spedizione = new Address($order->id_address_delivery);

    $ret = $this->dettaglioSincroCustomer($indirizzo_fatturazione->id_customer);



    if(isset($ret["id_customer_winddoc"]) && $ret["id_customer_winddoc"]!=""){
      return $ret["id_customer_winddoc"];
    }else{
      $data = array();
      $data["tipo_contatto"] = 1;//tipo contatto lo impostiamo come cliente
      if($indirizzo_fatturazione->vat_number=="" && $indirizzo_fatturazione->dni!=""){
        $data["nome"] = trim($indirizzo_fatturazione->firstname." ".$indirizzo_fatturazione->lastname);
        $data["codice_fiscale"] = $indirizzo_fatturazione->dni;
        $data["ragione_sociale"] = "";
        $data["indirizzo_citta"] = $indirizzo_fatturazione->city;
        $Country = new Country($indirizzo_fatturazione->id_country);
        $data["indirizzo_nazione"] = $Country->iso_code;
        $data["indirizzo_cap"] = $indirizzo_fatturazione->postcode;
        if (!empty($indirizzo_fatturazione->id_state)){
            $state = new State($indirizzo_fatturazione->id_state);
            $data["indirizzo_provincia"] =$state->iso_code;
        }
        $data["indirizzo_via"] = trim($indirizzo_fatturazione->address1." ".$indirizzo_fatturazione->address2);
        $data["partita_iva"] = "";
        $data["email"] = $customer->email;
        $data["codice_destinatario"] = "";
        $data["email_pec"] = "";
      }else{
        $data["nome"] = trim($indirizzo_fatturazione->firstname." ".$indirizzo_fatturazione->lastname);
        if($data["nome"]==""){
          $data["nome"] = $indirizzo_fatturazione->company;
        }
        $data["codice_fiscale"] = $indirizzo_fatturazione->dni;
        $data["ragione_sociale"] = $indirizzo_fatturazione->company;
        $data["indirizzo_citta"] = $indirizzo_fatturazione->city;
        $Country = new Country($indirizzo_fatturazione->id_country);
        $data["indirizzo_nazione"] = $Country->iso_code;
        $data["indirizzo_cap"] = $indirizzo_fatturazione->postcode;
        if (!empty($indirizzo_fatturazione->id_state)){
            $state = new State($indirizzo_fatturazione->id_state);
            $data["indirizzo_provincia"] =$state->iso_code;
        }
        $data["indirizzo_via"] = trim($indirizzo_fatturazione->address1." ".$indirizzo_fatturazione->address2);
        $data["partita_iva"] = $indirizzo_fatturazione->vat_number;
        $data["email"] = $customer->email;
        $data["codice_destinatario"] = "";
        $data["email_pec"] = "";
      }




      $WindDocTalker = new WindDocTalker();

      $ret = $WindDocTalker->aggiungiCustomer($data);
      $this->aggiungiSincroCustomer($indirizzo_fatturazione->id_customer,$ret);
      return $ret;
    }

  }

  public function getConti(){
    $WindDocTalker = new WindDocTalker();
    $template = $WindDocTalker->getConti();
    $ret = array();
    $ret["predefinito"] = "Predefinito";

    if(isset($template->lista) && count($template->lista)>0){
      foreach ($template->lista as $value) {
        $nome = "";
        $id_templatestampa = "";

        foreach ($value as $v) {
          if($v->name=="id_conto"){
            $id_templatestampa = $v->value;
          }
          if($v->name=="nome"){
            $nome = $v->value;
          }
        }
        $ret[$id_templatestampa] = $nome;
      }
    }

    return $ret;
  }

  public function getTemplateRicevute(){
    $WindDocTalker = new WindDocTalker();
    $template = $WindDocTalker->getTemplateRicevute();
    $ret = array();
    $ret["predefinito"] = "Predefinito";
    if(isset($template->lista) && count($template->lista)>0){
      foreach ($template->lista as $value) {
        $nome = "";
        $id_templatestampa = "";
        foreach ($value as $v) {
          if($v->name=="id_templatestampa"){
            $id_templatestampa = $v->value;
          }
          if($v->name=="nome"){
            $nome = $v->value;
          }
        }
        $ret[$id_templatestampa] = $nome;
      }
    }
    return $ret;
  }

  public function getTemplateInvoice(){
    $WindDocTalker = new WindDocTalker();
    $template = $WindDocTalker->getTemplateInvoice();
    $ret = array();
    $ret["predefinito"] = "Predefinito";
    if(isset($template->lista) && count($template->lista)>0){
      foreach ($template->lista as $value) {
        $nome = "";
        $id_templatestampa = "";
        foreach ($value as $v) {
          if($v->name=="id_templatestampa"){
            $id_templatestampa = $v->value;
          }
          if($v->name=="nome"){
            $nome = $v->value;
          }
        }
        $ret[$id_templatestampa] = $nome;
      }
    }
    return $ret;
  }

  public function getTemplateQuote(){
    $WindDocTalker = new WindDocTalker();
    $template = $WindDocTalker->getTemplateQuote();
    $ret = array();
    $ret["predefinito"] = "Predefinito";
    if(isset($template->lista) && count($template->lista)>0){
      foreach ($template->lista as $value) {
        $nome = "";
        $id_templatestampa = "";
        foreach ($value as $v) {
          if($v->name=="id_templatestampa"){
            $id_templatestampa = $v->value;
          }
          if($v->name=="nome"){
            $nome = $v->value;
          }
        }
        $ret[$id_templatestampa] = $nome;
      }
    }
    return $ret;
  }



}







class WindDocTalker
{
    private $url;
    private $soapclient;
    private $sessionId;
    private $token_app = "8e07ba5637b912f08a414de463212ccbaf06aa8b1633efff7bb90bb375d9293b";

    function __construct(){

      $this->url = 'https://app.winddoc.com/v1/api.php?wsdl';
      $this->soapclient = new SoapClient(null,
                                         array('location' => $this->url,
                                         'uri'            => $this->url,
                                         'soap_version'   => SOAP_1_1,
                                         'trace'          => 1,
                                         'exceptions'     => 0
                                        ));
    }


  public function sendDocument($data,$tipo){
    if($this->Login()){

      $args = array(
        new SoapParam($this->sessionId,  'id_session'),
        new SoapParam($this->paseData($data),  'params'),
      );

      if($tipo=="fatture"){
        $ret = $this->__call("fatture_aggiungi", $args);
        return $ret;
      }
      if($tipo=="ricevute"){
        $ret = $this->__call("ricevute_aggiungi", $args);
        return $ret;
      }
      if($tipo=="ordini"){
        $ret = $this->__call("ordini_aggiungi", $args);
        return $ret;
      }
      $this->Close();
    }
  }

  public function aggiungiCustomer($data){
    if($this->Login()){
      $args = array(
        new SoapParam($this->sessionId,  'id_session'),
        new SoapParam($this->paseData($data),  'params'),
      );

      $ret = $this->__call("contatti_aggiungi", $args);

      $this->Close();
      return $ret;


    }
  }

  public function getConti(){
    if($this->Login()){
      $args = array(
        new SoapParam($this->sessionId,  'id_session'),
        new SoapParam("1",  'pagina'),
      );
      $ret = $this->__call("settings_conti_lista", $args);
      $this->Close();
      return $ret;
    }
  }


  public function getTemplateRicevute(){
    if($this->Login()){
      $args = array(
        new SoapParam($this->sessionId,  'id_session'),
        new SoapParam("1",  'pagina'),
      );
      $ret = $this->__call("ricevute_listaTemplate", $args);
      $this->Close();
      return $ret;
    }
  }


  public function getTemplateQuote(){
    if($this->Login()){
      $args = array(
        new SoapParam($this->sessionId,  'id_session'),
        new SoapParam("1",  'pagina'),
      );
      $ret = $this->__call("ordini_listaTemplate", $args);
      $this->Close();
      return $ret;
    }
  }

  public function getTemplateInvoice(){
    if($this->Login()){
      $args = array(
        new SoapParam($this->sessionId,  'id_session'),
        new SoapParam("1",  'pagina'),
      );
      $ret = $this->__call("fatture_listaTemplate", $args);
      $this->Close();
      return $ret;
    }
  }


  public function paseData($data){

		$args = array();
    foreach ($data as $key => $value) {
      if(is_array($value)){
        $args[] = new SoapParam($this->paseData($value),  $key);
      }else{
        $args[] = new SoapParam($value,  $key);
      }
    }

		return $args;
	}

	public function Login(){
		$args = array(
		 'token' => Configuration::get("PS_WINDDOC_TOKEN"),
		 'token_app' => $this->token_app
		);
	  $this->sessionId = $this->__call("login", $args);

    if($this->sessionId!=""){
      return true;
    }
    return false;
	}

  public function Close(){

		$args = array(
		 'id_session' => $this->sessionId
		);

	  $this->__call("close", $args);
	}


	public function __call($method, $args){

	   //return call_user_func_array(array($this->soapclient, $method), $args);
     $response = $this->soapclient->__soapCall($method, $args);

     if(is_object($response) && get_class($response)=="SoapFault"){
       return array();
     }
     return $response;

  }


}
